#include "Position.h"
#include "Figure.h"
#include "Pawn.h"
#include "Horse.h"
#include "Bishop.h"
#include "Rook.h"
#include "Queen.h"
#include "King.h"
#include <iostream>
#include <vector>

using namespace std;

int main() {
    vector<Figure*> figures;
    Pawn p(Position('A', '1'), 'W');
    figures.push_back(&p);
    Horse h(Position('B', '1'), 'B');
    figures.push_back(&h);
    Bishop b(Position('C', '1'), 'W');
    figures.push_back(&b);
    Rook r(Position('D', '1'), 'W');
    figures.push_back(&r);
    Queen q(Position('E', '1'), 'W');
    figures.push_back(&q);
    King k(Position('F', '1'), 'B');
    figures.push_back(&k);

    vector<Position> moves;
    for (int i = 0; i < 6; i++) {
        moves = figures[i]->get_moves();
        cout << figures[i]->print() << ' ' << moves.size() << ' ';
        for(int j = 0; j < moves.size(); j++) {
            cout << moves[j] << ';';
        }
        cout << endl;
    }
    return 0;
}